package com.jzlife.report.controller;

import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.dto.JzOrderAssignDTO;
import com.jzlife.report.service.JzOrderAssignService;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.vo.JzOrderAssignVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

@RestController
@RequestMapping("/jzOrderAssign")
@Api(value = "JzOrderAssign-Controller", description = "私域订单分配情况")
public class JzOrderAssignController {

    @Autowired
    private JzOrderAssignService jzOrderAssignService;

    @ApiOperation(value = "私域订单逐日分配情况", httpMethod = "POST", notes = "时间格式为：yyyy-MM-dd")
    @PostMapping("/dailyAssign")
    @LogRecordFiled(funName = "私域订单逐日分配情况")
    public Object dailyAssign(
            @Validated  @RequestBody JzOrderAssignVo vo,
            HttpServletResponse response ) throws Exception {
        if (null != vo.getIsExport() && vo.getIsExport()) {
            List<JzOrderAssignDTO> result = jzOrderAssignService.dailyAssignNoPage(vo);
            ExcelUtils.exportExcel(result, "私域订单分配情况("+vo.getStartDay()+"至"+vo.getEndDay()+")", "私域订单分配情况", JzOrderAssignDTO.class, "私域订单分配情况", response);
            return null;
        }
        if (null== vo.getPageNo()) {
            vo.setPageNo(1);
        }
        if (null== vo.getPageSize()) {
            vo.setPageSize(10);
        }
        if (StringUtils.isNotEmpty(vo.getFraName())) {
            vo.setFraName(vo.getFraName().trim());
        }
        if (StringUtils.isNotEmpty(vo.getCityName())) {
            vo.setCityName(vo.getCityName().trim());
        }
        return ResponseUtil.ok(jzOrderAssignService.dailyAssign(vo));
    }
}
