package com.jzlife.report.controller;

import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.dto.export.SelfRebuyDetailDTO;
import com.jzlife.report.service.ReBuy2Service;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.vo.SelfReBuyQueryVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.List;
import java.util.concurrent.ExecutionException;

@RestController
@RequestMapping("selfreBuy")
@Api(value = "SelfRebuyController", description = "复购看板")
public class SelfRebuyController {
    @Autowired
    private ReBuy2Service reBuy2Service;

    @ApiOperation(value = "复购-折线图")
    @PostMapping("selfReBuyLine")
    @LogRecordFiled(funName = "复购看板-折线图")
    public Object reBuyLine(@Valid @RequestBody SelfReBuyQueryVo vo, HttpServletRequest request) throws ExecutionException, InterruptedException {
        vo.setUserId(Integer.parseInt(request.getHeader("userId")));
        return ResponseUtil.ok(reBuy2Service.selfReBuyLine(vo));
    }

    @ApiOperation(value = "加盟商列表")
    @GetMapping("getFraList")
    @LogRecordFiled(funName = "复购看板-加盟商列表")
    public Object getFraList() {
        return ResponseUtil.ok(reBuy2Service.getFraList());
    }

    @ApiOperation(value = "复购-明细")
    @PostMapping("selfReBuyDetail")
    @LogRecordFiled(funName = "复购看板-明细")
    public Object selfReBuyDetail(@Valid @RequestBody SelfReBuyQueryVo vo, HttpServletResponse response) throws Exception {

        if (null!=vo.getIsExport()&&vo.getIsExport()) {
            List<SelfRebuyDetailDTO> list = reBuy2Service.selfReBuyDetailNoPage(vo);
            if (list != null && !list.isEmpty()) {
                ExcelUtils.exportExcel(list, "复购明细", "Sheet1", SelfRebuyDetailDTO.class, "复购明细",
                        response);
            }
        }
        return ResponseUtil.ok(reBuy2Service.selfReBuyDetailPage(vo));
    }
}
