package com.jzlife.report.dao.manager;

import com.jzlife.report.dto.export.OnceFilingTicketExportDto;
import com.jzlife.report.excelExport.DayCustomerClaimDetailDTO;
import com.jzlife.report.excelExport.ReportComplaintmanagementDTO;
import com.jzlife.report.vo.DayReportBaseVo;
import org.apache.ibatis.annotations.Param;

import javax.validation.constraints.NotBlank;
import java.util.List;
import java.util.Map;

public interface ServiceQualityReportMapper {
    List<Map<String, Object>> selectOrderAndClaimList(
            @Param("startTime") String startTime,
            @Param("endTime") String endTime,
            @Param("city") @NotBlank String city,
            @Param("serviceStation") String serviceStation);

    List<Map<String, Object>> selectClaimList(@Param("startTime") String startTime,
                                              @Param("endTime") String endTime,
                                              @Param("city") @NotBlank String city,
                                              @Param("serviceStation") String serviceStation);


    List<Map<String, Object>> selectOrderSourceDistribution(@Param("city") @NotBlank String city,
                                                            @Param("serviceStation") String serviceStation,
                                                            @Param("startTime") String startTime,
                                                            @Param("endTime") String endTime);

    //进线接听率、外呼接听率、现存客诉单、平均处理时效、S级工单、>48小时工单
    Map<String, Object> selectSomePoint();

    List<Map<String, Object>> selectTicketResult(@Param("city") @NotBlank String city,
                                                 @Param("serviceStation") String serviceStation,
                                                 @Param("startTime") String startTime,
                                                 @Param("endTime") String endTime);

    //保洁异常报备
    List<Map<String, Object>> selectExceptionReport(@Param("city") @NotBlank String city,
                                                    @Param("serviceStation") String serviceStation,
                                                    @Param("startTime") String startTime,
                                                    @Param("endTime") String endTime);

    List<String> getExecptionReportType();

    List<Map<String, Object>> dayCustomerClaimDetail(DayReportBaseVo vo);


    //导出查询
    List<DayCustomerClaimDetailDTO> dayCustomerClaimDetailNoPage(DayReportBaseVo baseVo);

    //投诉治理
    List<ReportComplaintmanagementDTO> complaintManagementExport(@Param("city") String city, @Param("serviceStation") String serviceStation,
                                                                 @Param("serverName") String serverName, @Param("ticketSn") String ticketSn,
                                                                 @Param("hemaWorkOrder") String hemaWorkOrder, @Param("startTime") String startTime,
                                                                 @Param("endTime") String endTime);
    //一键报备
    List<OnceFilingTicketExportDto> getOnceFilingTicket(@Param("startDate")String startDate, 
    		@Param("endDate")String endDate,@Param("city") String city);

    
}
