package com.jzlife.report.dao.reports;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.jzlife.report.dto.douyin.DouyinBoardMapVo;
import com.jzlife.report.dto.privatedomain.GoodsSalesInfo;
import com.jzlife.report.dto.privatedomain.goodsCitySalesInfo;

public interface ReportPrivateDomainMapper {

	// 顶部昨日、当月销售；加盟商数量
	Map<String, Object> daySales(@Param("day") String day);

	Map<String, Object> monthSales(@Param("month") String month);

	Map<String, Object> jmsNumber(@Param("month") String month);

	// 核销热力图
	List<DouyinBoardMapVo> getServicedHotMap(@Param("days") Integer days);

	// 城市销量排行
	List<Map<String, Object>> citySalesRank(@Param("month") String month, @Param("day") String day,
			@Param("limit") Integer limit);

	// 城市销量排行
	List<Map<String, Object>> jmsSalesRank(@Param("month") String month, @Param("day") String day,
			@Param("limit") Integer limit);

	// 履约排行
	List<Map<String, Object>> performanceRank(@Param("month") String month, @Param("day") String day,
			@Param("limit") Integer limit);

	// poi排行
	List<Map<String, Object>> poiRank(@Param("month") String month, @Param("day") String day,
			@Param("limit") Integer limit);

	
	/**
	 * 商品销售排行
	 * @param month
	 * @param day
	 * @param limit
	 * @return
	 */
	List<GoodsSalesInfo> goodsSalesRank(@Param("month") String month, @Param("day") String day,
			@Param("limit") Integer limit);
	
	/**
	 * 某商品城市下销量
	 * @param month
	 * @param day
	 * @param goodsIds
	 * @return
	 */
	List<goodsCitySalesInfo> goodsCityRank(@Param("month") String month, @Param("day") String day,
			@Param("goodsIds") String goodsIds);

}
