package com.jzlife.report.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 离职原因&流失原因记录表
 */
@ApiModel(value = "离职原因&流失原因记录表")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class EntryResignLossRecord {
    private Integer id;

    /**
     * 保洁师id
     */
    private Integer workerId;

    /**
     * 保洁编号
     */
    private String workerNo;

    /**
     * 保洁手机号
     */
    private String phone;

    /**
     * 线索状态
     */
    private Integer clueState;

    private String clueStateDesc;

    /**
     * 服务者状态worker_supplier表同状态
     */
    private Integer workerState;

    /**
     * 状态描述
     */
    private String workerStateDescribe;

    /**
     * 0状态日记记录，1.离职 2流失，
     3线索录入-待分配，4线索分配-跟进中，5线索跟进成功，6发起上线审批，7上线审批结果，8复职
     */
    private Byte type;

    /**
     * 一级分类
     */
    private String levelOne;

    private String levelOneValue;

    /**
     * 二级分类
     */
    private String levelTwo;

    private String levelTwoValue;

    /**
     * 三级分类
     */
    private String levelThree;

    private String levelThreeValue;

    /**
     * 创建时间
     */
    private Date createTime;

    private String createBy;

    /**
     * 更新时间
     */
    private Date updateTime;

    private String updateBy;
}
