package com.jzlife.report.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@ApiModel(value = "电访任务汇总报表")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class OBCallTask {

    @ApiModelProperty(value="任务名称")
    private String campaignName;

    private Integer campaignId;

    @ApiModelProperty(value="任务数量")
    private Integer total;

    @ApiModelProperty(value="坐席名称")
    private String userName;

    @ApiModelProperty(value="已拨打")
    private Integer dialed;


    @ApiModelProperty(value="未拨打")
    private Integer noDialed;


    @ApiModelProperty(value="拨打成功")
    private Integer dialedSuccess;


    @ApiModelProperty(value="未接通")
    private Integer noConnect;

    @ApiModelProperty(value="拒访")
    private Integer reject;


    @ApiModelProperty(value="已建工单数量")
    private Integer tickets;

    //明细数据 分配到个人的数据跟进情况
    private List<OBCallTaskDetail> detailList;

}
