package com.jzlife.report.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
    * 30天商品库存
    */
@ApiModel(value="30天商品库存")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Report30daysProductStocks {
    @ApiModelProperty(value="")
    private Integer id;

    /**
    * 库存业务时间
    */
    @ApiModelProperty(value="库存业务时间")
    private String stockDate;

    /**
    * 供应商
    */
    @ApiModelProperty(value="供应商")
    private String supplier;

    /**
    * 门店名称
    */
    @ApiModelProperty(value="门店名称")
    private String shopName;

    /**
    * skucode
    */
    @ApiModelProperty(value="skucode")
    private Long sku;

    /**
    * 商品id
    */
    @ApiModelProperty(value="商品id")
    private Long productId;

    /**
    * 商品名称
    */
    @ApiModelProperty(value="商品名称")
    private String productName;

    /**
    * 时间段
    */
    @ApiModelProperty(value="时间段")
    private String timeStamp;

    /**
    * 总份数
    */
    @ApiModelProperty(value="总份数")
    private Integer totalCount;

    /**
    * 剩余可用份数
    */
    @ApiModelProperty(value="剩余可用份数")
    private Integer freeCount;

    /**
    * 导入时间
    */
    @ApiModelProperty(value="导入时间")
    private Date importTime;
}