package com.jzlife.report.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 订单按照地址聚合索引表
 */
@ApiModel(value = "订单按照地址聚合索引表")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class ReportOrderCoalescence {
    @ApiModelProperty(value = "")
    private Integer id;

    /**
     * 订单编号
     */
    @ApiModelProperty(value = "订单编号")
    private String orderNo;

    /**
     * 城市
     */
    @ApiModelProperty(value = "城市")
    private String city;

    /**
     * 业务时间  订单创建时间
     */
    @ApiModelProperty(value = "业务时间  订单创建时间")
    private Date buinessDate;

    /**
     * 门店名称
     */
    @ApiModelProperty(value = "门店名称")
    private String shopName;

    /**
     * 标准订单地址
     */
    @ApiModelProperty(value = "标准订单地址")
    private String formattedOrderAddress;

    /**
     * 区名
     */
    @ApiModelProperty(value = "区名")
    private String district;

    /**
     * 街道名
     */
    @ApiModelProperty(value = "街道名")
    private String township;

    /**
     * 街道下的住宅
     */
    @ApiModelProperty(value = "街道下的住宅")
    private String address;

    /**
     * 客户地址
     */
    @ApiModelProperty(value = "客户地址")
    private String customerAddr;

    /**
     * 客户地址经度
     */
    @ApiModelProperty(value = "客户地址经度")
    private String customerLongitude;

    /**
     * 客户地址纬度
     */
    @ApiModelProperty(value = "客户地址纬度")
    private String customerLatitude;

    /**
     * 服务站编号
     */
    @ApiModelProperty(value = "服务站编号")
    private String stationCode;

    /**
     * 服务站名称
     */
    @ApiModelProperty(value = "服务站名称")
    private String stationName;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createUser;
}