package com.jzlife.report.service;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.read.listener.ReadListener;
import com.jzlife.report.dao.hmorder.ReportEvaluationMapper;
import com.jzlife.report.entity.hmorder.ReportEvaluation;
import com.jzlife.report.util.SpringContextUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;

@Slf4j
public class EvaluationListeners implements ReadListener<ReportEvaluation> {

    private String batchNo;

    private ReportEvaluationMapper evaluationMapper;

    private List<ReportEvaluation> list = new LinkedList<>();

    public EvaluationListeners(String times) {
        this.batchNo = times;
        evaluationMapper = SpringContextUtils.getBeanByClass(ReportEvaluationMapper.class);
    }

    @Override
    public void invoke(ReportEvaluation data, AnalysisContext context) {
        if (data.getEvaluateTime() == null) {
            return;
        }
        data.setBatchNo(batchNo);
        data.setInsertTime(new Date());
        if (null != data.getTaoId()) {
            data.setTaoId(data.getTaoId().replace("淘", ""));
        }
        list.add(data);
        int max_count = 1000;
        if (list.size() >= max_count) {
            evaluationMapper.batchInsert(list);
            list.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        if (list.size() > 0) {
            evaluationMapper.batchInsert(list);
            list.clear();
        }
        evaluationMapper.deleteBatchDate(batchNo);
        evaluationMapper.insert_temp_evaluate();
    }

}
