package com.jzlife.report.service;

import com.alibaba.excel.context.AnalysisContext;
import com.jzlife.report.dao.nurse.Report30daysProductStocksMapper;
import com.jzlife.report.dto.Report30daysProductStocks;
import com.jzlife.report.dto.excelimport.LifeServiceImportData;
import org.springframework.beans.BeanUtils;

import java.util.Arrays;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

public class LifeServiceListener implements com.alibaba.excel.read.listener.ReadListener<LifeServiceImportData> {


    private Report30daysProductStocksMapper daysProductStocksMapper;

    private List<Report30daysProductStocks> list = new LinkedList<>();

    private int max_count = 1000;

    public LifeServiceListener(Report30daysProductStocksMapper daysStocksMapper) {
        this.daysProductStocksMapper = daysStocksMapper;
    }

    @Override
    public void invoke(LifeServiceImportData data, AnalysisContext context) {
        Report30daysProductStocks report30daysProductStocks = new Report30daysProductStocks();
        BeanUtils.copyProperties(data, report30daysProductStocks);
        List<String> strings = Arrays.asList("上海东方懿", "上海盒马鲜生维");
        List<String> realShopName = Arrays.asList("上海东方懿徳店", "上海盒马鲜生维璟印象城店");
        for (int i = 0; i < strings.size(); i++) {
            if (data.getShopName().contains(strings.get(i))) {
                report30daysProductStocks.setShopName(realShopName.get(i));
            }
        }
        report30daysProductStocks.setProductId(Long.parseLong(data.getProductId()));
        report30daysProductStocks.setImportTime(new Date());
        list.add(report30daysProductStocks);
        if (list.size() >= max_count) {
            daysProductStocksMapper.batchInsert(list);
            list.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        if (list.size() > 0) {
            daysProductStocksMapper.batchInsert(list);
            list.clear();
        }
    }
}
