package com.jzlife.report.service.newreport;

import com.jzlife.report.dto.*;
import com.jzlife.report.vo.DayReportBaseVo;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * 市场部报表相关
 */
public interface MarketReportService {

    /**
     * 新客复购率报表
     */
    List<ReportNewCustomerRebuy> getNewCustomerRebuyList(String month,String cType,String rebuy);

    /**
     * 销售提醒报表
     * @param pageNo
     * @param pageSize
     * @param city
     * @param bookDate
     * @return
     */
    List<ReportMarketRebuyRemind> getMarketRebuyRemindByCity(Integer pageNo, Integer  pageSize, String city, String bookDate);

    /**
     * 订单及新客数
     * @param month
     * @param pageNo
     * @param pageSize
     * @return
     */
    List<ReportSalesNewcustomerV3> getNewCustomer(String month,Integer pageNo, Integer  pageSize);

    /**
     * 老客续存率
     * 老客续约率：周期卡内最后一次服务完成后30天内，有未使用的、未预约的、履约中的订单
     * @param month
     * @return
     */
    List<ReportOldCustomerRebuy> getOldCustomerRebuy(String month);


    /**
     * 保洁新客首次服务后T+7复购率
     *
     * @param vo
     * @return
     */
    List<ReportNewCustomerRebuyBJTotal> serviceNewCustomerRebuyBJTotal(String month);

    //2022双11
    Object getMarketActivity202211(Integer type);

}
