package com.jzlife.report.service.newreport.impl;

import com.jzlife.report.dao.nurse.SysUserauthMapper;
import com.jzlife.report.service.newreport.PrivilegeManService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.Map;


@Service
public class PrivilegeManServiceImpl implements PrivilegeManService {

    @Autowired
    private SysUserauthMapper sysUserauthMapper;

    @Override
    public boolean getPrivilegeManByUserId(Integer userId) {
        String citys = sysUserauthMapper.getPrivilegeManByUserId(userId);
        if (StringUtils.isEmpty(citys)) {
            return false;
        }
        return Arrays.stream(citys.split(",")).filter(a -> a.equals("0")).findFirst().orElse(null) != null;
    }

    @Override
    public String getPrivilegeManCityByUserId(Integer userId) {
        return sysUserauthMapper.getPrivilegeManCityByUserId(userId);
    }

    @Override
    public Map<String, String> getPrivilegeByUserIdAndType(Integer userId, String type) {
        return sysUserauthMapper.getPrivilegeByUserIdAndType(userId, type);
    }
}
