package com.jzlife.report.service.newreport.impl;


import com.alibaba.excel.EasyExcel;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.compent.EasyExcelListener;
import com.jzlife.report.config.SendSms;
import com.jzlife.report.constant.GaoDeMapConstants;
import com.jzlife.report.dao.hmorder.EtlGoalMapper;
import com.jzlife.report.dao.manager.ServicePowerReportMapper;
import com.jzlife.report.dao.nurse.Report14daysCityStackRadioMapper;
import com.jzlife.report.dao.nurse.Report30daysProductStocksMapper;
import com.jzlife.report.dao.nurse.Report30daysProductStocksResultMapper;
import com.jzlife.report.dao.nurse.ReportOrderCoalescenceMapper;
import com.jzlife.report.dao.reports.Report14daysCityStackRadioPersonMapper;
import com.jzlife.report.dto.Report14daysCityStackRadio;
import com.jzlife.report.dto.Report30daysProductStocks;
import com.jzlife.report.dto.Report30daysProductStocksResult;
import com.jzlife.report.dto.ReportOrderCoalescence;
import com.jzlife.report.entity.hmorder.Districts;
import com.jzlife.report.entity.hmorder.DistrictsItem;
import com.jzlife.report.entity.reports.ImportDataRecord;
import com.jzlife.report.excelExport.*;
import com.jzlife.report.service.newreport.ServicePowerReportService;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.vo.*;
import lombok.extern.slf4j.Slf4j;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.time.temporal.TemporalAdjusters;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.util.stream.Collectors;


@Service
@Slf4j
public class ServicePowerReportServiceImpl implements ServicePowerReportService {


    @Autowired
    private ServicePowerReportMapper servicePowerReportMapper;

    @Autowired
    EtlGoalMapper etlgoalMapper;

    @Autowired
    Report14daysCityStackRadioMapper radioMapper;

    @Autowired
    Report30daysProductStocksMapper daysStocksMapper;

    @Autowired
    Report30daysProductStocksResultMapper daysProductStocksResultMapper;

    @Autowired
    ReportOrderCoalescenceMapper reportOrderCoalescenceMapper;

    OkHttpClient client = new OkHttpClient().newBuilder().connectTimeout(10, TimeUnit.SECONDS).readTimeout(30, TimeUnit.SECONDS).build();

    Map<String, String> jsonMap = new HashMap<>(2);

    @Autowired
    RedisTemplate<String, Object> redisTemplate;

    @Autowired
    private Report14daysCityStackRadioPersonMapper report14daysCityStackRadioPersonMapper;

    @Override
    public PageInfo<Map<String, Object>> servicePowerTicketDetail(DayReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerTicketDetail(vo));

    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerTicketInfo(DayReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerTicketInfo(vo));
    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerServerInfo(DayReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerServerInfo(vo));
    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerStationPersonInfo(DayReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerStationPersonInfo(vo));
    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerRentFee(ReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerRentFee(vo));
    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerWornSubsidies(ReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerWornSubsidies(vo));
    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerTeacherReward(ReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerTeacherReward(vo));
    }

    @Override
    public PageInfo<Map<String, Object>> servicePowerOrderReward(ReportBaseVo vo) {
        PageHelper.startPage(vo.getStartPage(), vo.getLimit());
        return new PageInfo<>(servicePowerReportMapper.servicePowerOrderReward(vo));
    }


    private List<List<Report30daysProductStocks>> splitList(List<Report30daysProductStocks> list) {
        int length = list.size();
        // 计算可以分成多少组
        int num = (length + 1000 - 1) / 1000;
        List<List<Report30daysProductStocks>> newList = new ArrayList<>(num);
        for (int i = 0; i < num; i++) {
            // 开始位置
            int fromIndex = i * 1000;
            // 结束位置
            int toIndex = Math.min((i + 1) * 1000, length);
            newList.add(list.subList(fromIndex, toIndex));
        }
        return newList;
    }

    @Override
    public void import30DaysProductStock(List<Report30daysProductStocks> stations, String s) {
        List<List<Report30daysProductStocks>> lists = splitList(stations);
        long start = System.currentTimeMillis();
        daysStocksMapper.trancatTable();
        for (List<Report30daysProductStocks> list : lists) {
            daysStocksMapper.batchInsert(list);
        }
        long end = System.currentTimeMillis();
        System.out.println((end - start) / 1000);
        Report30daysProductStocksResult result = daysProductStocksResultMapper.selectNoFinshBySerialNo(s);
        result.setResultType(3);
        result.setUpdateTime(new Date());
        daysProductStocksResultMapper.updateByPrimaryKeySelective(result);
        daysProductStocksResultMapper.callSP_server_power();
    }

    public void import30DayProductStockData(List<List<String>> importList) {
        Object object = redisTemplate.opsForValue().get("import30daysproductstocktask");
        Integer ct = Integer.parseInt(object.toString());


        log.info("盒马30天商品库存插入db");
        List<Report30daysProductStocks> stations = new ArrayList<>();
        for (int i = 0; i < importList.size(); i++) {
            if (i > 0) {
                try {
                    List<String> e = importList.get(i);//(List<String>)
                    Report30daysProductStocks aa = new Report30daysProductStocks();
                    aa.setStockDate(e.get(0));
                    aa.setSupplier(e.get(1));
                    aa.setShopName(e.get(2));
                    aa.setSku(Long.valueOf(e.get(3)));
                    aa.setProductId(Long.valueOf(e.get(4)));
                    aa.setProductName(e.get(5));
                    aa.setTimeStamp(e.get(6));
                    aa.setTotalCount(Integer.parseInt(e.get(7)));
                    aa.setFreeCount(Integer.parseInt(e.get(8)));
                    stations.add(aa);
                } catch (Exception e) {
                    ct++;
                    log.error("导入import30DaysProductStock csv异常信息行：", e);
                }
            }
        }
        daysStocksMapper.batchInsert(stations);

        redisTemplate.opsForValue().set("import30daysproductstocktask", ct, 10, TimeUnit.MINUTES);
    }

    @Override
    public int get14DayBatchId() {
        return radioMapper.getCurrentBatchId();
    }

    public void import30DaysProductStockTask(String filePath, ImportDataRecord dr) {
        //List<Report30daysProductStocks> stations

        log.info("准备执行import30DaysProductStock，清空表");
        daysStocksMapper.trancatTable();

        //存储计算行数
        redisTemplate.opsForValue().set("import30daysproductstocktask", 0, 10, TimeUnit.MINUTES);

        log.info("准备执行import30DaysProductStock，导入");
//        daysStocksMapper.batchInsert(list);
        if (filePath.endsWith("csv")) {
            try {
                File file = new File(filePath);
                EasyExcelListener.importCsv(new FileInputStream(file), new EasyExcelListener(dr));
            } catch (Exception e) {
                log.error("导入import30DaysProductStock csv异常信息：", e);

            }
        } else {
            try {
                File file = new File(filePath);
                EasyExcel.read(new FileInputStream(file), new EasyExcelListener(dr)).sheet().headRowNumber(1).doRead();
            } catch (Exception e) {
                log.error("导入import30DaysProductStock异常信息：", e);

            }
        }

        log.info("准备执行callSP_server_power函数处理");
        daysProductStocksResultMapper.callSP_server_power();

        log.info("import30DaysProductStock------处理结束");

        //发送通知
        Object object = redisTemplate.opsForValue().get("import30daysproductstocktask");
        Integer ct = Integer.parseInt(object.toString());
        if (ct > 0) {
            SendSms.toSendMs_Import("30天Stock导入失败数量:" + ct);
        }

        redisTemplate.delete("import30daysproductstocktask");
    }


    @Override
    public Object get30DaysProductStockResult(String serialNo) {
        Report30daysProductStocksResult result = daysProductStocksResultMapper.selectBySerialNo(serialNo);
        if (result == null) {
            return ResponseUtil.fail400("请求流水号无效");
        }
        return ResponseUtil.ok(result);
    }

    @Override
    public List<Map<String, Object>> service14DayStock(String city, String userId) {
        return radioMapper.selectStockRadio(city, userId);
    }


    @Override
    public Map<String, Object> serviceGoalData(String month, String userId, String city) {
        //判断参数 是否是当月
        String thisMonth = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyy-MM"));
        Map<String, Object> result = new HashMap<>();
        String year = month.split("-")[0];
        if (thisMonth.equals(month) && Integer.parseInt(year) == LocalDate.now().getYear()) {
            // 是当月 多返回当日信息 保洁当日单量&品类当日单量  服务站纬度下  当日单量& 环比上日
            setcurrMonthResultMap(result, userId, city);
        } else {
            // 非当日， 返回 月信息
            setResultMap(result, userId, month.split("-")[1], month.split("-")[0], city);
        }
        //  设置 档期满载率、人均订单、人均工时、全天班人数占比，白班人数占比
        setOtherInfo(result, userId, month.split("-")[1], month.split("-")[0], city);
        return result;
    }

    private void setOtherInfo(Map<String, Object> result, String userId, String month, String year, String city) {
        String startTime = LocalDate.now().withYear(Integer.parseInt(year)).withMonth(Integer.parseInt(month)).with(TemporalAdjusters.firstDayOfMonth()).toString();
        String endTime;
        if (LocalDate.now().getMonthValue() == Integer.parseInt(month) && LocalDate.now().getYear() == Integer.parseInt(year)) {
            endTime = String.valueOf(LocalDate.now().minusDays(1));
        } else {
            endTime = LocalDate.now().withYear(Integer.parseInt(year)).withMonth(Integer.parseInt(month)).with(TemporalAdjusters.lastDayOfMonth()).toString();
        }
        Map<String, Object> otherInfo = servicePowerReportMapper.getOtherInfo(startTime, endTime, userId, city);
        Map<String, Object> someIndex = (Map<String, Object>) result.get("servicePowerIndex");
        if (someIndex != null && null != otherInfo && !otherInfo.isEmpty()) {
            someIndex.putAll(otherInfo);
        }
    }

    private void setResultMap(Map<String, Object> result, String userId, String month, String year, String city) {
        LocalDate now = LocalDate.now().withYear(Integer.parseInt(year)).withMonth(Integer.parseInt(month));
        LocalDate firstDayOfMonth = now.with(TemporalAdjusters.firstDayOfMonth());
        LocalDate lastDayOfMonth = now.with(TemporalAdjusters.lastDayOfMonth());
        Map<String, Object> someIndex = servicePowerReportMapper.selectNoCurrPowerInfo(firstDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")),
                lastDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")), userId, city);
        result.put("servicePowerIndex", someIndex);
        //查询服务站指标
        List<Map<String, Object>> stationIndex = servicePowerReportMapper.selectNoCurrSatationInfo(firstDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")),
                lastDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")), userId, city);
        result.put("stationIndex", stationIndex);
    }

    // 所需日期是 当月，补充 当日情况
    private void setcurrMonthResultMap(Map<String, Object> result, String userId, String city) {
        LocalDate now = LocalDate.now().minusDays(1);
        LocalDate firstDayOfMonth = now.with(TemporalAdjusters.firstDayOfMonth());
        LocalDate lastDayOfMonth = now.with(TemporalAdjusters.lastDayOfMonth());
        Map<String, Object> someIndex = servicePowerReportMapper.selectCurrPowerInfo(now.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")),
                firstDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")), lastDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")), userId, city);
        result.put("servicePowerIndex", someIndex);
        //查询服务站指标
        List<Map<String, Object>> stationIndex = servicePowerReportMapper.selectCurrSatationInfo(now.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")),
                firstDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")), lastDayOfMonth.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")), userId, city);
        result.put("stationIndex", stationIndex);
    }

    @Override
    public Map<String, Object> stationAndShopStock(ReportStationAndShopVo vo) {
        Map<String, Object> result = new HashMap<>();

        //  服务站和商品 逐日 剩余率
        Map<String, Object> stockRadio = new HashMap<>();
        long t1 = System.currentTimeMillis();
        List<Map<String, Object>> mapList = servicePowerReportMapper.selectStationAndShopStockInfo(vo);
        long t2 = System.currentTimeMillis();
        log.info("数据库查询服务站每日 剩余率 耗时=" + (t2 - t1) / 1000 + "s");
        List<String> dates = mapList.stream().map(a -> (String) a.get("stock_date")).collect(Collectors.toList());
        stockRadio.put("dates", dates);
        // 门店 剩余率
        stockRadio.put("productStockRadio", mapList.stream().map(a -> (String) a.get("product_stock_radio")).collect(Collectors.toList()));
        // 服务站库存 剩余率
        stockRadio.put("server_stock_radio", mapList.stream().map(a -> (String) a.get("server_stock_radio")).collect(Collectors.toList()));
        result.put("stockRadio", stockRadio);
        // 查询剩余率看板
        Map<String, Object> residualRadio = new HashMap<>();
        long t3 = System.currentTimeMillis();
        List<Map<String, Object>> list = servicePowerReportMapper.selectResidualRadio(vo);
        long t4 = System.currentTimeMillis();
        log.info("数据库查询剩余率看板耗时=" + (t4 - t3) / 1000 + "s");
        List<Map<String, Object>> type = list.stream().filter(a -> (Long) a.get("type") == 1).map(a -> {
            Map<String, Object> temp = new HashMap<>(a);
            temp.remove("type");
            return temp;
        }).collect(Collectors.toList());
        list.sort((o1, o2) -> {

            String s1 = (String) o1.get("one_to_fourteen_radio");
            String s2 = (String) o2.get("one_to_fourteen_radio");
            if (null == s1 || null == s2) {
                return 0;
            }
            String t11 = s1.split("%")[0];
            String t21 = s2.split("%")[0];
            return new BigDecimal(t11).compareTo(new BigDecimal(t21));
        });
        residualRadio.put("shopInfo", type);
        List<Map<String, Object>> station = list.stream().filter(a -> (Long) a.get("type") == 2).map(this::transalte).sorted((o1, o2) -> {
            String s1 = (String) o1.get("one_to_fourteen_radio");
            String s2 = (String) o2.get("one_to_fourteen_radio");
            if (null == s1 || null == s2) {
                return 0;
            }
            String t11 = s1.split("%")[0];
            String t21 = s2.split("%")[0];
            return new BigDecimal(t11).compareTo(new BigDecimal(t21));
        }).collect(Collectors.toList());
        residualRadio.put("station", station);
        result.put("residualRadio", residualRadio);
        return result;
    }

    /**
     * {
     * "lnglat": ["116.502159141883", "39.857389101662"],
     * "district": "朝阳区",
     * "community": "翠成馨园",
     * "building": "垡头翠成馨园",
     * "area": "垡头",
     * "city": "北京"
     * }
     *
     * @param vo
     * @return
     */
    @Override
    public Map<String, Object> createOrderHeatMap(BaseRequestVo vo) {
        Map<String, Object> objectMap = new HashMap<>();
        long startT = System.currentTimeMillis();
        List<ReportOrderCoalescence> reportOrderCoalescenceList = reportOrderCoalescenceMapper.getLocationByVo(vo);
        long l3 = System.currentTimeMillis();
        log.info("查询数据库耗时：" + (l3 - startT) / 1000 + "s");
        List<Map<String, Object>> points = new ArrayList<>();
        reportOrderCoalescenceList.forEach(reportOrderCoalescence -> {
            Map<String, Object> businessMap = new HashMap<>();
            String[] array = new String[]{reportOrderCoalescence.getCustomerLongitude(), reportOrderCoalescence.getCustomerLatitude()};
            businessMap.put("lnglat", array);
            businessMap.put("city", reportOrderCoalescence.getCity());
            if (StringUtils.isEmpty(reportOrderCoalescence.getFormattedOrderAddress())) {
                Map<String, Object> formatAddress = getFormattedAddress(reportOrderCoalescence.getCustomerLongitude(), reportOrderCoalescence.getCustomerLatitude());
                businessMap.put("district", formatAddress.get("district"));
                businessMap.put("community", formatAddress.get("community"));
                businessMap.put("building", formatAddress.get("building"));
                businessMap.put("area", formatAddress.get("area"));
                reportOrderCoalescence.setFormattedOrderAddress((String) formatAddress.get("formattedAddress"));
                reportOrderCoalescence.setDistrict((String) formatAddress.get("district"));
                reportOrderCoalescence.setTownship((String) formatAddress.get("area"));
                reportOrderCoalescence.setAddress((String) formatAddress.get("community"));
                reportOrderCoalescenceMapper.updateByPrimaryKeySelective(reportOrderCoalescence);
            } else {
                businessMap.put("district", reportOrderCoalescence.getDistrict());
                businessMap.put("community", reportOrderCoalescence.getAddress());
                businessMap.put("building", reportOrderCoalescence.getTownship() + reportOrderCoalescence.getAddress());
                businessMap.put("area", reportOrderCoalescence.getTownship());
            }
            points.add(businessMap);
        });
        long endT = System.currentTimeMillis();
        log.info("查询订单热力图耗时：" + (endT - l3) / 1000 + " s");
        objectMap.put("points", points);
        //获取行政规划区域
        long l1 = System.currentTimeMillis();
        getDistrict(objectMap);
        long l2 = System.currentTimeMillis();
        log.info("设置行政规划耗时：" + (l2 - l1) / 1000);
//        log.info("生成订单热力图接口出参：" + objectMap);
        return objectMap;
    }

    private void getDistrict(Map<String, Object> objectMap) {
        if (null != jsonMap && jsonMap.containsKey("createTime")) {
            long createTime = LocalDateTime.now().until(LocalDateTime.parse(jsonMap.get("createTime")), ChronoUnit.HOURS);
            if (createTime >= 24) {
                jsonMap.remove("json");
            }
        }
        if (null != jsonMap && jsonMap.containsKey("json")) {
            objectMap.put("district", jsonMap.get("json"));
            return;
        }
        List<String> citys = Arrays.asList("上海", "北京", "深圳", "南京", "苏州", "杭州");
        Map<String, Map<String, String>> outMap = new HashMap<>();
        for (String city : citys) {
            String param = GaoDeMapConstants.getDistrictURL + "?key=" + GaoDeMapConstants.apiKey + "&output=JSON&subdistrict=2&keywords=" + city;
            Request request = new Request.Builder().url(param).build();
            try (Response response = client.newCall(request).execute()) {
                String string = Objects.requireNonNull(response.body()).string();
//                System.out.println("string = " + string);
                JSONObject jsonObject = JSONObject.parseObject(string);
                parseFailResult(jsonObject, "调用高德查询行政区域失败，失败原因：");
                Districts districts = JSONObject.parseObject(string, Districts.class);
                List<DistrictsItem> items = districts.getDistricts();
                DistrictsItem districtsItem = items.get(0);
                Map<String, String> cityMap = new HashMap<>();
                String adcode = districtsItem.getAdcode();
                String center = districtsItem.getCenter();
                cityMap.put("adcode", adcode);
                cityMap.put("center", center);
                outMap.put(city, cityMap);
                DistrictsItem districtsTwo = districtsItem.getDistricts().get(0);
                Map<String, String> stringMap = new HashMap<>();
                String twoCenter = districtsTwo.getCenter();
                String twoAdcode = districtsTwo.getAdcode();
                stringMap.put("adcode", twoAdcode);
                stringMap.put("center", twoCenter);
                outMap.put(districtsTwo.getName(), stringMap);
                List<DistrictsItem> itemList = districtsTwo.getDistricts();
                for (DistrictsItem item : itemList) {
                    Map<String, String> map = new HashMap<>();
                    String districtsTwoCenter = item.getCenter();
                    String districtsTwoAdcode = item.getAdcode();
                    String itemName = item.getName();
                    map.put("adcode", districtsTwoAdcode);
                    map.put("center", districtsTwoCenter);
                    outMap.put(itemName, map);
                }
            } catch (IOException e) {
                log.error("调用高德地图查询行政区域失败，失败原因：" + e.getMessage());
            }
        }
        String json = JSONArray.toJSONString(outMap);
        objectMap.put("district", json);
        jsonMap.put("json", json);
        jsonMap.put("createTime", LocalDateTime.now().toString());
//        System.out.println("json=" + json);

    }

    private void parseFailResult(JSONObject jsonObject, String x) {
        if (!jsonObject.getString("status").equals("1")) {
            String infocode = jsonObject.getString("infocode");
            String jsonType = "[\n" + "  {\n" + "    \"错误码\": 10000,\n" + "    \"错误内容\": \"OK\",\n" + "    \"状态描述\": \"请求正常\",\n" + "    \"问题排查\": \"请求正常\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10001,\n" + "    \"错误内容\": \"INVALID_USER_KEY\",\n" + "    \"状态描述\": \"key不正确或过期\",\n" + "    \"问题排查\": \"开发者发起请求时，传入的key不正确或者过期\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10002,\n" + "    \"错误内容\": \"SERVICE_NOT_AVAILABLE\",\n" + "    \"状态描述\": \"没有权限使用相应的服务或者请求接口的路径拼写错误\",\n" + "    \"问题排查\": \"1.开发者没有权限使用相应的服务，例如：开发者申请了WEB定位功能的key，却使用该key访问逆地理编码功能时，就会返回该错误。反之亦然。2.开发者请求接口的路径拼写错误。例如：正确的https://restapi.amap.com/ **v3** /ip在程序中被拼装写了https://restapi.amap.com/ **vv3** /ip\\\"\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10003,\n" + "    \"错误内容\": \"DAILY_QUERY_OVER_LIMIT\",\n" + "    \"状态描述\": \"访问已超出日访问量\",\n" + "    \"问题排查\": \"开发者的日访问量超限，被系统自动封停，第二天0:00会自动解封。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10004,\n" + "    \"错误内容\": \"ACCESS_TOO_FREQUENT\",\n" + "    \"状态描述\": \"单位时间内访问过于频繁\",\n" + "    \"问题排查\": \"开发者的单位时间内（1分钟）访问量超限，被系统自动封停，下一分钟自动解封。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10005,\n" + "    \"错误内容\": \"INVALID_USER_IP\",\n" + "    \"状态描述\": \"IP白名单出错，发送请求的服务器IP不在IP白名单内\",\n" + "    \"问题排查\": \"开发者在LBS官网控制台设置的IP白名单不正确。白名单中未添加对应服务器的出口IP\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10006,\n" + "    \"错误内容\": \"INVALID_USER_DOMAIN\",\n" + "    \"状态描述\": \"绑定域名无效\",\n" + "    \"问题排查\": \"开发者绑定的域名无效，需要在官网控制台重新设置\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10007,\n" + "    \"错误内容\": \"INVALID_USER_SIGNATURE\",\n" + "    \"状态描述\": \"数字签名未通过验证\",\n" + "    \"问题排查\": \"开发者签名未通过开发者在key控制台中，开启了“数字签名”功能，但没有按照指定算法生成“数字签名”。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10008,\n" + "    \"错误内容\": \"INVALID_USER_SCODE\",\n" + "    \"状态描述\": \"MD5安全码未通过验证\",\n" + "    \"问题排查\": \"需要开发者判定key绑定的SHA1,package是否与sdk包里的一致\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10009,\n" + "    \"错误内容\": \"USERKEY_PLAT_NOMATCH\",\n" + "    \"状态描述\": \"请求key与绑定平台不符\",\n" + "    \"问题排查\": \"请求中使用的key与绑定平台不符，例如：开发者申请的是js api的key，却用来调web服务接口\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10010,\n" + "    \"错误内容\": \"IP_QUERY_OVER_LIMIT\",\n" + "    \"状态描述\": \"IP访问超限\",\n" + "    \"问题排查\": \"未设定IP白名单的开发者使用key发起请求，从单个IP向服务器发送的请求次数超出限制，被系统自动封停。封停后无法自动恢复，需要提交[工单](https://lbs.amap.com/dev/ticket/create/24)联系我们。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10011,\n" + "    \"错误内容\": \"NOT_SUPPORT_HTTPS\",\n" + "    \"状态描述\": \"服务不支持https请求\",\n" + "    \"问题排查\": \"服务不支持https请求，如果需要申请支持，请提交[工单](https://lbs.amap.com/dev/ticket/create/24)联系我们\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10012,\n" + "    \"错误内容\": \"INSUFFICIENT_PRIVILEGES\",\n" + "    \"状态描述\": \"权限不足，服务请求被拒绝\",\n" + "    \"问题排查\": \"由于不具备请求该服务的权限，所以服务被拒绝。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10013,\n" + "    \"错误内容\": \"USER_KEY_RECYCLED\",\n" + "    \"状态描述\": \"Key被删除\",\n" + "    \"问题排查\": \"开发者删除了key，key被删除后无法正常使用\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10014,\n" + "    \"错误内容\": \"QPS_HAS_EXCEEDED_THE_LIMIT\",\n" + "    \"状态描述\": \"云图服务QPS超限\",\n" + "    \"问题排查\": \"QPS超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10015,\n" + "    \"错误内容\": \"GATEWAY_TIMEOUT\",\n" + "    \"状态描述\": \"受单机QPS限流限制\",\n" + "    \"问题排查\": \"受单机QPS限流限制时出现该问题，建议降低请求的QPS或在控制台提工单联系我们\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10016,\n" + "    \"错误内容\": \"SERVER_IS_BUSY\",\n" + "    \"状态描述\": \"服务器负载过高\",\n" + "    \"问题排查\": \"服务器负载过高，请稍后再试\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10017,\n" + "    \"错误内容\": \"RESOURCE_UNAVAILABLE\",\n" + "    \"状态描述\": \"所请求的资源不可用\",\n" + "    \"问题排查\": \"所请求的资源不可用\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10019,\n" + "    \"错误内容\": \"CQPS_HAS_EXCEEDED_THE_LIMIT\",\n" + "    \"状态描述\": \"使用的某个服务总QPS超限\",\n" + "    \"问题排查\": \"QPS超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10020,\n" + "    \"错误内容\": \"CKQPS_HAS_EXCEEDED_THE_LIMIT\",\n" + "    \"状态描述\": \"某个Key使用某个服务接口QPS超出限制\",\n" + "    \"问题排查\": \"QPS超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10021,\n" + "    \"错误内容\": \"CUQPS_HAS_EXCEEDED_THE_LIMIT\",\n" + "    \"状态描述\": \"账号使用某个服务接口QPS超出限制\",\n" + "    \"问题排查\": \"QPS超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10026,\n" + "    \"错误内容\": \"INVALID_REQUEST\",\n" + "    \"状态描述\": \"账号处于被封禁状态\",\n" + "    \"问题排查\": \"由于违规行为账号被封禁不可用，如有异议请登录[控制台](https://console.amap.com/dev/index)提交工单进行申诉\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10029,\n" + "    \"错误内容\": \"ABROAD_DAILY_QUERY_OVER_LIMIT\",\n" + "    \"状态描述\": \"某个Key的QPS超出限制\",\n" + "    \"问题排查\": \"QPS超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10041,\n" + "    \"错误内容\": \"NO_EFFECTIVE_INTERFACE\",\n" + "    \"状态描述\": \"请求的接口权限过期\",\n" + "    \"问题排查\": \"开发者发起请求时，请求的接口权限过期。请提交[工单](https://lbs.amap.com/dev/ticket/create/24)联系我们\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10044,\n" + "    \"错误内容\": \"USER_DAILY_QUERY_OVER_LIMIT\",\n" + "    \"状态描述\": \"账号维度日调用量超出限制\",\n" + "    \"问题排查\": \"账号维度日调用量超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 10045,\n" + "    \"错误内容\": \"USER_ABROAD_DAILY_QUERY_OVER_LIMIT\",\n" + "    \"状态描述\": \"账号维度海外服务日调用量超出限制\",\n" + "    \"问题排查\": \"账号维度海外服务接口日调用量超出限制，超出部分的请求被拒绝。限流阈值内的请求依旧会正常返回\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20000,\n" + "    \"错误内容\": \"INVALID_PARAMS\",\n" + "    \"状态描述\": \"请求参数非法\",\n" + "    \"问题排查\": \"请求参数的值没有按照规范要求填写。例如，某参数值域范围为[1,3],开发者误填了’4’\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20001,\n" + "    \"错误内容\": \"MISSING_REQUIRED_PARAMS\",\n" + "    \"状态描述\": \"缺少必填参数\",\n" + "    \"问题排查\": \"缺少接口中要求的必填参数\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20002,\n" + "    \"错误内容\": \"ILLEGAL_REQUEST\",\n" + "    \"状态描述\": \"请求协议非法\",\n" + "    \"问题排查\": \"请求协议非法比如某接口仅支持get请求，结果用了POST方式\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20003,\n" + "    \"错误内容\": \"UNKNOWN_ERROR\",\n" + "    \"状态描述\": \"其他未知错误\",\n" + "    \"问题排查\": \"其他未知错误\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20011,\n" + "    \"错误内容\": \"INSUFFICIENT_ABROAD_PRIVILEGES\",\n" + "    \"状态描述\": \"查询坐标或规划点（包括起点、终点、途经点）在海外，但没有海外地图权限\",\n" + "    \"问题排查\": \"使用逆地理编码接口、输入提示接口、周边搜索接口、路径规划接口时可能出现该问题，规划点（包括起点、终点、途经点）不在中国陆地范围内\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20012,\n" + "    \"错误内容\": \"ILLEGAL_CONTENT\",\n" + "    \"状态描述\": \"查询信息存在非法内容\",\n" + "    \"问题排查\": \"使用搜索接口时可能出现该问题，通常是由于查询内容非法导致\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20800,\n" + "    \"错误内容\": \"OUT_OF_SERVICE\",\n" + "    \"状态描述\": \"规划点（包括起点、终点、途经点）不在中国陆地范围内\",\n" + "    \"问题排查\": \"使用路径规划服务接口时可能出现该问题，规划点（包括起点、终点、途经点）不在中国陆地范围内\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20801,\n" + "    \"错误内容\": \"NO_ROADS_NEARBY\",\n" + "    \"状态描述\": \"划点（起点、终点、途经点）附近搜不到路\",\n" + "    \"问题排查\": \"使用路径规划服务接口时可能出现该问题，划点（起点、终点、途经点）附近搜不到路\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20802,\n" + "    \"错误内容\": \"ROUTE_FAIL\",\n" + "    \"状态描述\": \"路线计算失败，通常是由于道路连通关系导致\",\n" + "    \"问题排查\": \"使用路径规划服务接口时可能出现该问题，路线计算失败，通常是由于道路连通关系导致\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 20803,\n" + "    \"错误内容\": \"OVER_DIRECTION_RANGE\",\n" + "    \"状态描述\": \"起点终点距离过长。\",\n" + "    \"问题排查\": \"使用路径规划服务接口时可能出现该问题，路线计算失败，通常是由于道路起点和终点距离过长导致。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": \"300**\",\n" + "    \"错误内容\": \"ENGINE_RESPONSE_DATA_ERROR\",\n" + "    \"状态描述\": \"服务响应失败。\",\n" + "    \"问题排查\": \"出现3开头的错误码，建议先检查传入参数是否正确，若无法解决，请详细描述错误复现信息，提[`工单`](https://lbs.amap.com/dev/ticket/create/24)给我们。（大数据接口请直接跟负责商务反馈）如，30001、30002、30003、32000、32001、32002、32003、32200、32201、32202、32203。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 40000,\n" + "    \"错误内容\": \"QUOTA_PLAN_RUN_OUT\",\n" + "    \"状态描述\": \"余额耗尽\",\n" + "    \"问题排查\": \"所购买服务的余额耗尽，无法继续使用服务\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 40001,\n" + "    \"错误内容\": \"GEOFENCE_MAX_COUNT_REACHED\",\n" + "    \"状态描述\": \"围栏个数达到上限\",\n" + "    \"问题排查\": \"Key可创建的地理围栏的数量，已达上限。\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 40002,\n" + "    \"错误内容\": \"SERVICE_EXPIRED\",\n" + "    \"状态描述\": \"购买服务到期\",\n" + "    \"问题排查\": \"所购买的服务期限已到，无法继续使用\"\n" + "  },\n" + "  {\n" + "    \"错误码\": 40003,\n" + "    \"错误内容\": \"ABROAD_QUOTA_PLAN_RUN_OUT\",\n" + "    \"状态描述\": \"海外服务余额耗尽\",\n" + "    \"问题排查\": \"所购买服务的海外余额耗尽，无法继续使用服务\"\n" + "  }\n" + "]";
            List<Map> mapList = JSONArray.parseArray(jsonType).toJavaList(Map.class);
            mapList.forEach(a -> {
                if (a.get("错误码").equals(Integer.parseInt(infocode))) {
                    log.warn(x + a.get("状态描述") + "高德建议：" + a.get("问题排查"));
                    throw new RuntimeException((String) a.get("状态描述"));
                }
            });
        }
    }

    private Map<String, Object> getFormattedAddress(String customerLongitude, String customerLatitude) {
        Map<String, Object> addressMap = new HashMap<>();
        String param = GaoDeMapConstants.getLocationByCoordinateUrl + "&key=" + GaoDeMapConstants.apiKey + "&output=JSON&extensions=base" + "&location=" + customerLongitude + "," + customerLatitude;
        Request request = new Request.Builder().url(param).build();
        try (Response response = client.newCall(request).execute()) {
            String string = Objects.requireNonNull(response.body()).string();
//            System.out.println("string = " + string);
            JSONObject jsonObject = JSONObject.parseObject(string);
            parseFailResult(jsonObject, "调用高德逆解析地图坐标失败，失败原因：");
            JSONObject cityObject = jsonObject.getJSONObject("regeocode").getJSONObject("addressComponent");
            String district = cityObject.getString("district"); //区
            addressMap.put("district", district);
            String township = cityObject.getString("township"); //XX 街道
            String formatted_address = jsonObject.getJSONObject("regeocode").getString("formatted_address");
            if (StringUtils.isEmpty(township) || township.equals("[]")) {
                //上海市普陀区金沙嘉年华金沙嘉年华园  没有街道信息返回的
                String location = formatted_address.split("区")[1];
                addressMap.put("area", location);
                addressMap.put("community", location);
                addressMap.put("building", township + location);
            } else {
                addressMap.put("area", township);
                String[] split = formatted_address.split(township);
                if (split.length > 1) {
                    String realArea = split[1];
                    addressMap.put("community", realArea);
                    addressMap.put("building", township + realArea);
                } else {
                    addressMap.put("community", township);
                    addressMap.put("building", township);
                }

            }
            addressMap.put("formattedAddress", formatted_address);
        } catch (IOException e) {
            log.error("调用高德地图逆解析地址失败，失败原因：" + e.getMessage());
            throw new RuntimeException(e.getMessage());
        }
        return addressMap;
    }

    public List<ReportOrderCoalescence> getOrderLocationByDay() {
        return reportOrderCoalescenceMapper.selectNeedRepairOrder();
    }


    @Override
    public void repairOrderLocation(List<ReportOrderCoalescence> reportOrderCoalescenceList) {
        updateOrderCoal(reportOrderCoalescenceList);
    }

    @Override
    public void repairOrderLocation() {
        List<ReportOrderCoalescence> reportOrderCoalescenceList = reportOrderCoalescenceMapper.selectNeedRepairOrder();
        updateOrderCoal(reportOrderCoalescenceList);
    }

    private void updateOrderCoal(List<ReportOrderCoalescence> reportOrderCoalescenceList) {
        reportOrderCoalescenceList.forEach(reportOrderCoalescence -> {
            Map<String, Object> formatAddress = getFormattedAddress(reportOrderCoalescence.getCustomerLongitude(), reportOrderCoalescence.getCustomerLatitude());
            reportOrderCoalescence.setFormattedOrderAddress((String) formatAddress.get("formattedAddress"));
            reportOrderCoalescence.setDistrict((String) formatAddress.get("district"));
            reportOrderCoalescence.setTownship((String) formatAddress.get("area"));
            reportOrderCoalescence.setAddress((String) formatAddress.get("community"));
            reportOrderCoalescenceMapper.updateByPrimaryKeySelective(reportOrderCoalescence);
        });
    }

    @Override
    public Object cleanPerCapitalOrderQuality(ReportCleanPerCaptchaOrderQualityVo vo) {
        Map<String, Object> result = new HashMap<>(2);
        if (vo.getTimeType() == 1) {
            // 按月查询
            setCleanPerCapitalOrderByMonth(result, vo);
        } else if (vo.getTimeType() == 2) {
            //按 天查询
            setCleanPerCapitalOrderByDay(result, vo);
        }
        return ResponseUtil.ok(result);
    }

    @Override
    public List<ServicePowerTicketDetailDTO> servicePowerTicketDetailNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerTicketDetailNoPage(vo);
    }

    @Override
    public List<ServicePowerTicketInfoDTO> servicePowerTicketInfoNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerTicketInfoNoPage(vo);

    }

    @Override
    public List<ServicePowerServerInfoDTO> servicePowerServerInfoNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerServerInfoNoPage(vo);
    }

    @Override
    public List<ServicePowerStationPersonInfoDTO> servicePowerStationPersonInfoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerStationPersonInfoNoPage(vo);
    }

    @Override
    public List<ServicePowerRentFeeDTO> servicePowerRentFeeNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerRentFeeNoPage(vo);
    }

    @Override
    public List<ServicePowerWornSubsidiesDTO> servicePowerWornSubsidiesNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerWornSubsidiesNoPage(vo);
    }

    @Override
    public List<ServicePowerTeacherRewardDTO> servicePowerTeacherRewardNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerTeacherRewardNoPage(vo);
    }

    @Override
    public List<ServicePowerOrderRewardDTO> servicePowerOrderRewardExportNoPage(DayReportBaseVo vo) {
        return servicePowerReportMapper.servicePowerOrderRewardNoPage(vo);
    }

    // 按日查询 保洁人均单量& 品类人均单量
    private void setCleanPerCapitalOrderByDay(Map<String, Object> result, ReportCleanPerCaptchaOrderQualityVo vo) {
        List<Map<String, Object>> temp = servicePowerReportMapper.selectCleanPerCapitalOrderByDay(vo.getCity(), vo.getServiceStation(), vo.getStartTime(), vo.getEndTime());
        List<String> buinessDate = temp.stream().map(a -> (String) a.get("buiness_date")).collect(Collectors.toList());
        result.put("everyDay", buinessDate);
        setCleanInfo(result, temp);
    }

    private void setCleanInfo(Map<String, Object> result, List<Map<String, Object>> temp) {
        List<String> avgOrders1 = temp.stream().map(a -> (String) a.get("per_avg_orders_1")).collect(Collectors.toList());
        result.put("avgOrders1", avgOrders1);
        List<String> avgOrders2 = temp.stream().map(a -> (String) a.get("per_avg_orders_2")).collect(Collectors.toList());
        result.put("avgOrders2", avgOrders2);
        List<String> perAvgWorkTime1 = temp.stream().map(a -> (String) a.get("per_avg_workTime_1")).collect(Collectors.toList());
        result.put("perAvgWorkTime1", perAvgWorkTime1);
        List<String> perAvgWorkTime2 = temp.stream().map(a -> (String) a.get("per_avg_workTime_2")).collect(Collectors.toList());
        result.put("perAvgWorkTime2", perAvgWorkTime2);
        List<BigDecimal> bjOrders = temp.stream().map(a -> (BigDecimal) a.get("bj_orders")).collect(Collectors.toList());
        result.put("bjOrders", bjOrders);
        List<BigDecimal> plOrders = temp.stream().map(a -> (BigDecimal) a.get("pl_orders")).collect(Collectors.toList());
        result.put("plOrders", plOrders);
        List<BigDecimal> jingxuanOrders = temp.stream().map(a -> (BigDecimal) a.get("jingxuan_orders")).collect(Collectors.toList());
        result.put("jingxuanOrders", jingxuanOrders);
    }

    // 按月查询 保洁人均单量& 品类人均单量
    private void setCleanPerCapitalOrderByMonth(Map<String, Object> result, ReportCleanPerCaptchaOrderQualityVo vo) {
        String start = LocalDate.parse(vo.getStartMonth() + "-01", DateTimeFormatter.ofPattern("yyyy-MM-dd")).toString();
        String end = LocalDate.parse(vo.getEndMonth() + "-01").with(TemporalAdjusters.lastDayOfMonth()).toString();
        String now = LocalDate.now().minusDays(1).toString();
        List<Map<String, Object>> temp = servicePowerReportMapper.selectCleanPerCapitalOrderByMonth(vo.getCity(), vo.getServiceStation(), start, end, now);
        List<String> month = temp.stream().map(a -> (String) a.get("month")).collect(Collectors.toList());
        result.put("everyMonth", month);
        setCleanInfo(result, temp);
    }


    private Map<String, Object> transalte(Map<String, Object> stringObjectMap) {
        Map<String, Object> temp = new HashMap<>(stringObjectMap);
        temp.put("station_name", temp.remove("shop_name"));
        temp.remove("type");
        return temp;
    }


    @Override
    public Map<String, Object> importData(List<DaysStackRadioVo> stations) {
        Map<String, Object> returnMap = new HashMap<>();
        List<String> success = new ArrayList<>();
        List<String> fail = new ArrayList<>();
        for (int i = stations.size() - 1; i >= 0; i--) {
            DaysStackRadioVo daysStackRadioVo = stations.get(i);
            String dateRegex = "\\d{8}";
            if (!daysStackRadioVo.getDate().matches(dateRegex)) {
                stations.remove(i);
                fail.add((i + 1) + "|日期格式错误");
            }
            List<String> cityList = Arrays.asList("北京", "上海", "深圳", "苏州", "南京", "杭州");
            if (!cityList.contains(daysStackRadioVo.getCity())) {
                stations.remove(i);
                fail.add(i + 1 + "|城市错误");
            }
            if (!daysStackRadioVo.getStationType().equals("保洁站") && !daysStackRadioVo.getStationType().equals("品类站")) {
                stations.remove(i);
                fail.add(i + 1 + "服务站类型错误");
            }
        }
        Lock lock = new ReentrantLock();
        lock.lock();
        int id = radioMapper.getCurrentBatchId();
        lock.unlock();
        List<Report14daysCityStackRadio> radios = new ArrayList<>();
        for (DaysStackRadioVo station : stations) {
            Report14daysCityStackRadio radio = new Report14daysCityStackRadio();
            if (station.getCurrentDayServerCount().matches("\\d+")) {
                radio.setCurrentDayServerCount(Integer.parseInt(station.getCurrentDayServerCount()));
            } else {
                radio.setCurrentDayServerCount(0);
            }
            BeanUtils.copyProperties(station, radio);
            radio.setBatchId(id);
            radios.add(radio);
        }
        radioMapper.batchInsert(radios);
        radioMapper.filterDelete(id);
        returnMap.put("success", success);
        returnMap.put("fail", fail);
        return returnMap;
    }

    @Override
    public int get14DayPersonBatchId() {
        return report14daysCityStackRadioPersonMapper.getCurrentBatchId();
    }

    @Override
    public void callProcedure() {
        report14daysCityStackRadioPersonMapper.callProcedure();
    }

}
