package com.jzlife.report.service.report.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.dao.reports.CPMapper;
import com.jzlife.report.dto.CPDailyCallVo;
import com.jzlife.report.dto.CPDetailVo;
import com.jzlife.report.dto.CPPreCollectVo;
import com.jzlife.report.dto.CPTotalVo;
import com.jzlife.report.service.report.CPService;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class CPServiceImpl implements CPService {

    @Autowired
    private CPMapper cpMapper;

    @Override
    public Object reportPreCollect(String startTime, String endTime, Integer campaignId, Integer pageIndex, Integer pageSize) {
        //PageHelper.startPage(pageIndex, pageSize);
        return cpMapper.selectPreCollect(startTime, endTime, campaignId);
    }

    @Override
    public Object reportCPJoin(String startTime, String endTime) {
        return cpMapper.selectCPJoin(startTime, endTime);
    }

    @Override
    public List<CPDailyCallVo> reportCPDailyCall(String startTime, String endTime, Integer pageIndex, Integer pageSize) {
        return cpMapper.selectDailyCall(startTime, endTime, pageIndex, pageSize);
    }


    //企微添加人数汇总
    @Override
    public List<CPTotalVo> selectCPTotal(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("pageIndex") Integer pageIndex, @Param("pageSize") Integer pageSize){
        return cpMapper.selectCPTotal(startTime,endTime,pageIndex,pageSize);
    }

    @Override
    public List<CPDetailVo> selectCPDetail(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("pageIndex") Integer pageIndex, @Param("pageSize") Integer pageSize){
        return cpMapper.selectCPDetail(startTime,endTime,pageIndex,pageSize);
    }


}
