package com.jzlife.report.service;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.read.listener.ReadListener;
import com.jzlife.report.dao.hmorder.ReportSignInMapper;
import com.jzlife.report.entity.hmorder.ReportSignIn;
import com.jzlife.report.util.DateUtil;
import com.jzlife.report.util.SpringContextUtils;

import java.util.Date;
import java.util.LinkedList;

public class signInListener implements ReadListener<ReportSignIn> {


    private LinkedList<ReportSignIn> tempDatas = new LinkedList<>();

    private final String times;


    private ReportSignInMapper reportSignInMapper;

    public signInListener(String times) {
        this.times = times;
        reportSignInMapper = SpringContextUtils.getBeanByClass(ReportSignInMapper.class);
    }

    @Override
    public void invoke(ReportSignIn data, AnalysisContext context) {
        data.setBatchNo(times);
        data.setCreateTime(new Date());
        data.setStartTime(getConvertVal(data.getStartTime2()));
        data.setOndoorTime(getConvertVal(data.getOndoorTime2()));
        data.setEndTime(getConvertVal(data.getEndTime2()));
        data.setAllprovideTime(getConvertVal(data.getAllprovideTime2()));
        tempDatas.add(data);

        int max_temp_count = 1000;
        if (tempDatas.size() >= max_temp_count) {
            reportSignInMapper.batchInsert(tempDatas);
            tempDatas.clear();
        }


    }

    public Date getConvertVal(String date) {
        if (null == date || date.equals("-")) {
            return null;
        }

        try {
            if (date.length() > 16) {
                return DateUtil.getDate(date);
            }
            return DateUtil.getDate2(date);
        } catch (Exception ignored) {

        }
        return null;
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        if (!tempDatas.isEmpty()) {
            reportSignInMapper.batchInsert(tempDatas);
            tempDatas.clear();
        }
        reportSignInMapper.deleteBatchDate();
    }
}
