package com.jzlife.report.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Calendar;
import java.util.Date;

public class DateUtil {

	public static String DATE_FORMAT = "yyyy-MM-dd";
	
	public static String DATE_FORMAT_YM = "yyyy-MM";

	public static String DATE_TIME_FORMAT_TIME = "yyyy-MM-dd HH:mm";

	public static String DATE_TIME_FORMAT = "yyyy-MM-dd HH:mm:ss";

	public static String DATE_FORMAT_CHINESE = "yyyy年M月d日";
	
	public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	public static SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy-MM-dd HH:mm");

	// String times = "2016-11-18 00:00:00";
	public static Date getDate(String times) {
		try {
			
			Date date = sdf.parse(times);
			return date;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	public static Date getDate2(String times) {
		try {
			
			Date date = sdf2.parse(times);
			return date;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * 获取当前日期
	 *
	 * @return
	 */
	public static String getCurrentDate() {
		String datestr = null;
		SimpleDateFormat df = new SimpleDateFormat(DateUtil.DATE_FORMAT);
		datestr = df.format(new Date());
		return datestr;
	}

	/**
	 * 获取当前日期时间
	 *
	 * @return
	 */
	public static String getCurrentDateTime() {
		String datestr = null;
		SimpleDateFormat df = new SimpleDateFormat(DateUtil.DATE_TIME_FORMAT);
		datestr = df.format(new Date());
		return datestr;
	}

	/**
	 * 获取当前日期时间
	 *
	 * @return
	 */
	public static String getCurrentDateTime(String Dateformat) {
		String datestr = null;
		SimpleDateFormat df = new SimpleDateFormat(Dateformat);
		datestr = df.format(new Date());
		return datestr;
	}

	public static String dateToDateTime(Date date) {
		String datestr = null;
		SimpleDateFormat df = new SimpleDateFormat(DateUtil.DATE_TIME_FORMAT);
		datestr = df.format(date);
		return datestr;
	}

	/**
	 * 将字符串日期转换为日期格式
	 *
	 * @param datestr
	 * @return
	 */
	public static Date stringToDate(String datestr) {

		if (datestr == null || datestr.equals("")) {
			return null;
		}
		Date date = new Date();
		SimpleDateFormat df = new SimpleDateFormat(DateUtil.DATE_FORMAT);
		try {
			date = df.parse(datestr);
		} catch (ParseException e) {
			date = DateUtil.stringToDate(datestr, "yyyy-MM-dd");
		}
		return date;
	}

	/**
	 * 将字符串日期转换为日期格式 自定義格式
	 *
	 * @param datestr
	 * @return
	 */
	public static Date stringToDate(String datestr, String dateformat) {
		Date date = new Date();
		SimpleDateFormat df = new SimpleDateFormat(dateformat);
		try {
			date = df.parse(datestr);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return date;
	}

	/**
	 * 将日期格式日期转换为字符串格式
	 *
	 * @param date
	 * @return
	 */
	public static String dateToString(Date date) {
		String datestr = null;
		SimpleDateFormat df = new SimpleDateFormat(DateUtil.DATE_FORMAT);
		datestr = df.format(date);
		return datestr;
	}

	/**
	 * 将日期格式日期转换为字符串格式 自定義格式
	 *
	 * @param date
	 * @param dateformat
	 * @return
	 */
	public static String dateToString(Date date, String dateformat) {
		String datestr = null;
		SimpleDateFormat df = new SimpleDateFormat(dateformat);
		datestr = df.format(date);
		return datestr;
	}

	/**
	 * 获取日期的DAY值
	 *
	 * @param date 输入日期
	 * @return
	 */
	public static int getDayOfDate(Date date) {
		int d = 0;
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);
		d = cd.get(Calendar.DAY_OF_MONTH);
		return d;
	}

	/**
	 * 获取日期的MONTH值
	 *
	 * @param date 输入日期
	 * @return
	 */
	public static int getMonthOfDate(Date date) {
		int m = 0;
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);
		m = cd.get(Calendar.MONTH) + 1;
		return m;
	}

	/**
	 * 获取日期的YEAR值
	 *
	 * @param date 输入日期
	 * @return
	 */
	public static int getYearOfDate(Date date) {
		int y = 0;
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);
		y = cd.get(Calendar.YEAR);
		return y;
	}

	/**
	 * 获取星期几
	 *
	 * @param date 输入日期
	 * @return
	 */
	public static int getWeekOfDate(Date date) {
		int wd = 0;
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);
		wd = cd.get(Calendar.DAY_OF_WEEK) - 1;
		return wd;
	}

	/**
	 * 获取输入日期的当月第一天
	 *
	 * @param date 输入日期
	 * @return
	 */
	public static Date getFirstDayOfMonth(Date date) {
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);
		cd.set(Calendar.DAY_OF_MONTH, 1);
		return cd.getTime();
	}

	/**
	 * 获得输入日期的当月最后一天
	 *
	 * @param date
	 */
	public static Date getLastDayOfMonth(Date date) {
		return DateUtil.addDay(DateUtil.getFirstDayOfMonth(DateUtil.addMonth(date, 1)), -1);
	}

	/**
	 * 判断是否是闰年
	 *
	 * @param date 输入日期
	 * @return 是true 否false
	 */
	public static boolean isLeapYEAR(Date date) {

		Calendar cd = Calendar.getInstance();
		cd.setTime(date);
		int year = cd.get(Calendar.YEAR);

		if (year % 4 == 0 && year % 100 != 0 | year % 400 == 0) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * 根据整型数表示的年月日，生成日期类型格式
	 *
	 * @param year  年
	 * @param month 月
	 * @param day   日
	 * @return
	 */
	public static Date getDateByYMD(int year, int month, int day) {
		Calendar cd = Calendar.getInstance();
		cd.set(year, month - 1, day, 0, 0, 0);
		cd.set(Calendar.MILLISECOND, 0);

		return cd.getTime();
	}

	/**
	 * 获取年周期对应日
	 *
	 * @param date  输入日期
	 * @param iyear 年数 負數表示之前
	 * @return
	 */
	public static Date getYearCycleOfDate(Date date, int iyear) {
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);

		cd.add(Calendar.YEAR, iyear);

		return cd.getTime();
	}

	/**
	 * 获取月周期对应日
	 *
	 * @param date 输入日期
	 * @param i
	 * @return
	 */
	public static Date getMonthCycleOfDate(Date date, int i) {
		Calendar cd = Calendar.getInstance();
		cd.setTime(date);

		cd.add(Calendar.MONTH, i);

		return cd.getTime();
	}

	/**
	 * 计算 fromDate 到 toDate 相差多少年
	 *
	 * @param fromDate
	 * @param toDate
	 * @return 年数
	 */
	public static int getYearByMinusDate(Date fromDate, Date toDate) {
		Calendar df = Calendar.getInstance();
		df.setTime(fromDate);

		Calendar dt = Calendar.getInstance();
		dt.setTime(toDate);

		return dt.get(Calendar.YEAR) - df.get(Calendar.YEAR);
	}

	/**
	 * 计算 fromDate 到 toDate 相差多少个月
	 *
	 * @param fromDate
	 * @param toDate
	 * @return 月数
	 */
	public static int getMonthByMinusDate(Date fromDate, Date toDate) {
		Calendar df = Calendar.getInstance();
		df.setTime(fromDate);

		Calendar dt = Calendar.getInstance();
		dt.setTime(toDate);

		return dt.get(Calendar.YEAR) * 12 + dt.get(Calendar.MONTH)
				- (df.get(Calendar.YEAR) * 12 + df.get(Calendar.MONTH));
	}

	/**
	 * 计算 fromDate 到 toDate 相差多少天
	 *
	 * @param fromDate
	 * @param toDate
	 * @return 天数
	 */
	public static long getDayByMinusDate(Object fromDate, Object toDate) {

		Date f = DateUtil.chgObject(fromDate);

		Date t = DateUtil.chgObject(toDate);

		long fd = f.getTime();
		long td = t.getTime();

		return (td - fd) / (24L * 60L * 60L * 1000L);
	}

	/**
	 * 计算年龄
	 *
	 * @param birthday 生日日期
	 * @param calcDate 要计算的日期点
	 * @return
	 */
	public static int calcAge(Date birthday, Date calcDate) {

		int cYear = DateUtil.getYearOfDate(calcDate);
		int cMonth = DateUtil.getMonthOfDate(calcDate);
		int cDay = DateUtil.getDayOfDate(calcDate);
		int bYear = DateUtil.getYearOfDate(birthday);
		int bMonth = DateUtil.getMonthOfDate(birthday);
		int bDay = DateUtil.getDayOfDate(birthday);

		if (cMonth > bMonth || (cMonth == bMonth && cDay > bDay)) {
			return cYear - bYear;
		} else {
			return cYear - 1 - bYear;
		}
	}

	/**
	 * 从身份证中获取出生日期
	 *
	 * @param idno 身份证号码
	 * @return
	 */
	public static String getBirthDayFromIDCard(String idno) {
		Calendar cd = Calendar.getInstance();
		if (idno.length() == 15) {
			cd.set(Calendar.YEAR, Integer.valueOf("19" + idno.substring(6, 8)).intValue());
			cd.set(Calendar.MONTH, Integer.valueOf(idno.substring(8, 10)).intValue() - 1);
			cd.set(Calendar.DAY_OF_MONTH, Integer.valueOf(idno.substring(10, 12)).intValue());
		} else if (idno.length() == 18) {
			cd.set(Calendar.YEAR, Integer.valueOf(idno.substring(6, 10)).intValue());
			cd.set(Calendar.MONTH, Integer.valueOf(idno.substring(10, 12)).intValue() - 1);
			cd.set(Calendar.DAY_OF_MONTH, Integer.valueOf(idno.substring(12, 14)).intValue());
		}
		return DateUtil.dateToString(cd.getTime());
	}

	/**
	 * 在输入日期上增加（+）或减去（-）天数
	 *
	 * @param date   输入日期
	 * @param imonth 要增加或减少的天数
	 */
	public static Date addDay(Date date, int iday) {
		Calendar cd = Calendar.getInstance();

		cd.setTime(date);

		cd.add(Calendar.DAY_OF_MONTH, iday);

		return cd.getTime();
	}

	/**
	 * @Author：
	 * 
	 * @Description：更加输入日期，获取输入日期的前一天 @Date：
	 * @strData：参数格式：yyyy-MM-dd
	 * @return：返回格式：yyyy-MM-dd
	 */
	public static String getPreDateByDate(String strData, int tian) {
		Calendar c = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Date date = null;
		try {
			date = sdf.parse(strData);
		} catch (java.text.ParseException e) {
			e.printStackTrace();
			return null;
		}

		c.setTime(date);
		int day1 = c.get(Calendar.DATE);
		c.set(Calendar.DATE, day1 + tian);// 减去一天 tian=-1
		return sdf.format(c.getTime());
	}

	/**
	 * 在输入日期上增加（+）或减去（-）月份
	 *
	 * @param date   输入日期
	 * @param imonth 要增加或减少的月分数
	 */
	public static Date addMonth(Date date, int imonth) {
		Calendar cd = Calendar.getInstance();

		cd.setTime(date);

		cd.add(Calendar.MONTH, imonth);
		Date d = cd.getTime();
		return d;
	}

	/**
	 * 在输入日期上增加（+）或减去（-）年份
	 *
	 * @param date   输入日期
	 * @param imonth 要增加或减少的年数
	 */
	public static Date addYear(Date date, int iyear) {
		Calendar cd = Calendar.getInstance();

		cd.setTime(date);

		cd.add(Calendar.YEAR, iyear);

		return cd.getTime();
	}

	/**
	 * 將OBJECT類型轉換為Date
	 *
	 * @param date
	 * @return
	 */
	public static Date chgObject(Object date) {

		if (date != null && date instanceof Date) {
			return (Date) date;
		}

		if (date != null && date instanceof String) {
			return DateUtil.stringToDate((String) date);
		}

		return null;

	}

	public static long getAgeByBirthday(String date) {

		Date birthday = stringToDate(date, "yyyy-MM-dd");
		long sec = new Date().getTime() - birthday.getTime();

		long age = sec / (1000 * 60 * 60 * 24) / 365;

		return age;
	}

	public static Integer getDatePoor(Date nowDate, Date endDate) {

		long nd = 1000 * 24 * 60 * 60;
		long nh = 1000 * 60 * 60;
		long nm = 1000 * 60;
		// long ns = 1000;
		// 获得两个时间的毫秒时间差异
		long diff = nowDate.getTime() - endDate.getTime();
		Integer min = (int) (diff / nm);
		return min;

		// 计算差多少天
//	    long day = diff / nd;
//	    // 计算差多少小时
//	    long hour = diff % nd / nh;
//	    // 计算差多少分钟
//	    long min = diff % nd % nh / nm;
//	    // 计算差多少秒//输出结果
//	    // long sec = diff % nd % nh % nm / ns;
//	    return day + "天" + hour + "小时" + min + "分钟";
	}

	public static boolean beWholeMonth(Date start, Date end) {
		LocalDate localDateStart = LocalDateTime.ofInstant(start.toInstant(), ZoneId.systemDefault()).toLocalDate();

		LocalDate localDateEnd = LocalDateTime.ofInstant(end.toInstant(), ZoneId.systemDefault()).toLocalDate();

		boolean bWholeMonth = !localDateStart.plusMonths(1).isAfter(localDateEnd.plusDays(1));

		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
		System.out.println("Start:" + localDateStart.format(formatter) + ",End:" + localDateEnd.format(formatter) + ","
				+ bWholeMonth);

		return bWholeMonth;
	}

	/**
	 * 给时间加多少秒
	 * 
	 * @param date
	 * @param second 30
	 * @return
	 */
	public static Date addTimeSecond(Date date, int second) {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		calendar.add(Calendar.SECOND, second);
		return calendar.getTime();
	}

	/**
	 * 判断是否当月最后一天
	 * 
	 * @param date
	 * @return
	 */
	public static boolean isLastDayOfMonth(Date date) {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		return calendar.get(Calendar.DAY_OF_MONTH) == calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
	}

	/**
	 * 是否当月第一天
	 * 
	 * @param date
	 * @return
	 */
	public static boolean isFirstDayOfMonth(Date date) {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
//		System.out.println(calendar.get(Calendar.MONTH));
		return calendar.get(Calendar.DAY_OF_MONTH) == 1;
	}
	
	//加减多少分钟
	public static Date addMinute(Integer minute) {
		Date now = new Date();
		long time = minute*60*1000;

		Date dt = new Date(now .getTime() + time);
		return dt;
	}
	
	public static String getStartOrEndDayOfDay(LocalDate time,long weeks, Boolean isFirst){
//        LocalDate time = LocalDate.parse(today, DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        LocalDate resDate = time.plusDays(weeks);
        String date;
        if (isFirst) {
             date =LocalDate.of(resDate.getYear(),resDate.getMonth(),resDate.getDayOfMonth())+"";
        } else {
             date =LocalDate.of(resDate.getYear(),resDate.getMonth(),resDate.getDayOfMonth())+"";
        }
        return date;
    } 
	//前多少天得到yyyy-mm-dd
	public static String getBeforeDay(Integer day) {
		return getStartOrEndDayOfDay(LocalDate.now(), day, true);
	}
	
	//前一天的月份yyyymm
	public static String getBeforeMonth(Integer day) {
		return getStartOrEndDayOfDay(LocalDate.now(), day, true).substring(0, 8).replace("-", "");
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
//		String str = getPreDateByDate("2019-10-01", -1);
//		System.out.println(str.substring(0, 7));
		
		String startOrEndDayOfDay = getBeforeDay(-1);
		System.out.println(startOrEndDayOfDay);
		
		String beforeMonth = getBeforeMonth(-1);
		System.out.println(beforeMonth);
	}

	// public static void main(String[] args) {
	// Date date = getDate("2016-8-8 23:59:59");
	// System.out.println(date);
	// }
}
