package com.jzlife.report.util.excel;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import com.jzlife.report.vo.ImportStationInfoVo;

public class ExcelReaderUtil {

	// excel2003扩展名
	public static final String EXCEL03_EXTENSION = ".xls";
	// excel2007扩展名
	public static final String EXCEL07_EXTENSION = ".xlsx";

	// 读取xls格式
	public static List<List<String>> readExcelXls(InputStream in) throws Exception {
		ExcelXlsReader excelXls = new ExcelXlsReader();
		List<List<String>> dataList = excelXls.process(in);
		return dataList;
	}

	// 读取xlsx格式
	public static List<List<String>> readExcelXlsx(InputStream in) throws Exception {
		ExcelXlsxReader excelXls = new ExcelXlsxReader();
		List<List<String>> dataList = excelXls.process(in);
		return dataList;
	}

	public static void readExcel(String fileName) throws Exception {
		int totalRows = 0;
		if (fileName.endsWith(EXCEL03_EXTENSION)) { // 处理excel2003文件
			ExcelXlsReader excelXls = new ExcelXlsReader();
			totalRows = excelXls.process(fileName);
		} else if (fileName.endsWith(EXCEL07_EXTENSION)) {// 处理excel2007文件
			ExcelXlsxReader excelXlsxReader = new ExcelXlsxReader();
			totalRows = excelXlsxReader.process(fileName);
		} else {
			throw new Exception("文件格式错误，fileName的扩展名只能是xls或xlsx。");
		}
		System.out.println("发送的总行数：" + totalRows);
	}

	public static void main(String[] args) throws Exception {
		Long start=System.currentTimeMillis();
		
		String path = "C:\\Users\\36952\\Desktop\\商品近30天库存.xlsx";
//        ExcelReaderUtil.readExcel(path);
		FileInputStream fileInputStream = new FileInputStream(path);
		List<List<String>> readExcelXlsx = readExcelXlsx(fileInputStream);
		System.out.println(readExcelXlsx.size());

		List<ImportStationInfoVo> stations = new ArrayList<ImportStationInfoVo>();//18
//		i[0] = 0;
		readExcelXlsx.forEach((e) -> {
			ImportStationInfoVo aa = new ImportStationInfoVo();

			aa.setWorkId(e.get(0));
			aa.setWorkPhone(e.get(1));
			aa.setType(e.get(2));
			aa.setLevelOne(e.get(3));
			aa.setLevelTwo(e.get(4));
			aa.setLevelThree(e.get(5));

			stations.add(aa);
 
		});
		System.out.println(stations.size());
		
		Long end=System.currentTimeMillis();
		System.out.println((end-start));
	}
}