package com.jzlife.report.util.file;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * 扫描文件夹下的文件
 * 
 * @author 36952
 *
 */
public class FolderFileScanner {

	private static ArrayList<String> scanFiles = new ArrayList<String>();

	/**
	 * 读取指定目录下的文件列表，不含文件夹 返回，文件名称，路径 k路径，v文件名称
	 * 
	 * @param folderPath
	 * @return
	 * @throws Exception
	 */
	public static Map<String, String> scanFiles(String folderPath) throws Exception {
		Map<String, String> dirctorys = new HashMap<String, String>();
		File directory = new File(folderPath);
		if (!directory.isDirectory()) {
			throw new Exception('"' + folderPath + '"'
					+ " input path is not a Directory , please input the right path of the Directory. ^_^...^_^");
		}

		if (directory.isDirectory()) {
			File[] filelist = directory.listFiles();
			for (int i = 0; i < filelist.length; i++) {
				if (!filelist[i].isDirectory()) {
					dirctorys.put(filelist[i].getAbsolutePath(), filelist[i].getName());
				}
			}
		}
		return dirctorys;
	}

	/**
	 * 读取文件大小
	 * 
	 * @param filename
	 * @return
	 */
	public static long getFileSize(String filename) {
		File file = new File(filename);
		if (!file.exists() || !file.isFile()) {
			System.out.println("文件不存在");
			return -1;
		}
		return file.length();
	}

	public static Boolean deleteFile(String filename) {
		File file = new File(filename);
		return file.delete();
	}

	/**
	 * 修改文件名称
	 * 
	 * @param sourceName 修改改前全路径名称
	 * @param rename     修改后的全路径名称
	 * @return
	 */
	public static Boolean fileRename(String sourceName, String rename) {
		System.out.println("原始："+sourceName);
		System.out.println("修改后："+rename);
		File file = new File(sourceName);
		return file.renameTo(new File(rename));
	}
	public static void main(String[] args) {
		fileRename("C:\\Users\\36952\\Desktop\\盒马-数据-甘威\\甘威\\盒马数据导入\\test\\22.xls", "C:\\Users\\36952\\Desktop\\盒马-数据-甘威\\甘威\\盒马数据导入\\test\\22-1111111111111111111111111111111.xls");
	}

	/**
	 * 
	 * TODO:递归扫描指定文件夹下面的指定文件
	 * 
	 */
	public static ArrayList scanFilesWithRecursion(String folderPath) throws Exception {
		ArrayList dirctorys = new ArrayList();
		File directory = new File(folderPath);
		if (!directory.isDirectory()) {
			throw new Exception('"' + folderPath + '"'
					+ " input path is not a Directory , please input the right path of the Directory. ^_^...^_^");
		}

		if (directory.isDirectory()) {
			File[] filelist = directory.listFiles();
			for (int i = 0; i < filelist.length; i++) {
				/** 如果当前是文件夹，进入递归扫描文件夹 **/

				if (filelist[i].isDirectory()) {
//					dirctorys.add(filelist[i].getAbsolutePath());
//					/** 递归扫描下面的文件夹 **/
//					scanFilesWithRecursion(filelist[i].getAbsolutePath());
				} else {
					scanFiles.add(filelist[i].getAbsolutePath());
				}
			}
		}
		return scanFiles;
	}

}