package com.jzlife.report.vo;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class BaseRequestVo {
    @ApiModelProperty(value = "城市名称")
    private String city;

    @ApiModelProperty(value = "开始时间", notes = "时间格式为 yyyy-MM-dd")
    @NotNull(message = "开始时间不可为空")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-(0[1-9]|1[0-9]|2[0-9]|3[01])$", message = "开始时间不合法")
    private String startTime;

    @ApiModelProperty(value = "结束时间", notes = "时间格式为 yyyy-MM-dd")
    @NotNull(message = "结束时间不可为空")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-(0[1-9]|1[0-9]|2[0-9]|3[01])$", message = "结束时间不合法")
    private String endTime;

    @ApiModelProperty(value = "服务站名称", notes = "盒马服务站名称")
    private String serviceStation;

    @ApiModelProperty(value = "门店名称", notes = "门店名称")
    private String shopName;

}
