package com.jzlife.report.vo;


import com.jzlife.report.anno.ExcelFiled;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class Days30ProductStockVo {

    /**
     * 时间，格式20211221
     */
    @ExcelFiled(colName = "库存业务时间", dateFormat = "yyyyMMdd")
    private String date;


    /**
     * 供应商
     */
    @ExcelFiled(colIndex = 1, colName = "供应商")
    private String supplier;

    /**
     * 服务站类型  保洁站、品类站
     */
    @ExcelFiled(colIndex = 2, colName = "门店")
    private String shopName;
    @ExcelFiled(colIndex = 3, colName = "skucode")
    private String sku;

    @ExcelFiled(colIndex = 4, colName = "商品id")
    private String productId;

    @ExcelFiled(colIndex = 5, colName = "商品名称")
    private String productName;
    @ExcelFiled(colIndex = 6, colName = "时间段")
    private String timeStamp;
    @ExcelFiled(colIndex = 7, colName = "总份数")
    private Integer totalCount;
    @ExcelFiled(colIndex = 8, colName = "剩余可用份数")
    private Integer freeCount;
}
